package articles;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class ArticleGUI extends JFrame {

    int w = 500;

    int h = 500;

    JList lstArticles;

    JPanel north;

    JPanel south;

    JButton btnSortName;

    JButton btnSortPrice;

    JButton btnAdd;

    JButton btnEdit;

    JButton btnDelete;

    JButton btnLoad;

    JButton btnSave;

    public ArticleGUI() {
	super();
	setPreferredSize(new Dimension(w, h));
	setVisible(true);
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	center();
	addComponents();
	pack();
    }

    void addComponents() {
	setLayout(new BorderLayout());

	north = new JPanel();
	btnSortName = new JButton("SortByName");
	btnSortPrice = new JButton("SortByPrice");
	btnAdd = new JButton("Add");
	btnEdit = new JButton("Edit");
	btnDelete = new JButton("Delete");
	north.add(btnSortName);
	north.add(btnSortPrice);
	north.add(btnAdd);
	north.add(btnEdit);
	north.add(btnDelete);
	add(north, BorderLayout.NORTH);

	Vector<Article> articles = new Vector<Article>();
	ArticleListModel model = new ArticleListModel(articles);
	articles.add(new Article(1, "Ves masina", 30000));
	articles.add(new Article(2, "Pegla", 5000));

	lstArticles = new JList(model);
	add(lstArticles, BorderLayout.CENTER);

	south = new JPanel();
	btnLoad = new JButton("load");
	btnSave = new JButton("save");
	south.add(btnLoad);
	south.add(btnSave);
	add(south, BorderLayout.SOUTH);

	btnSortName.addActionListener(new ActionListener() {
	    // SortByName
	    @Override
	    public void actionPerformed(ActionEvent e) {
		ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		model.sortByName();
	    }
	});
	btnSortPrice.addActionListener(new ActionListener() {
	    // SortByPrice
	    @Override
	    public void actionPerformed(ActionEvent e) {
		ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		model.sortByPrice();
	    }
	});
	btnAdd.addActionListener(new ActionListener() {
	    // add
	    @Override
	    public void actionPerformed(ActionEvent e) {
		String newArticle;
		ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		newArticle = JOptionPane.showInputDialog("Unesite novi artikal (ID, naziv, cena):");
		String token[] = newArticle.split(" ");
		model.add(new Article(Integer.parseInt(token[0]), token[1], Integer.parseInt(token[2])));
	    }
	});
	btnEdit.addActionListener(new ActionListener() {
	    // edit
	    @Override
	    public void actionPerformed(ActionEvent e) {
		if (!lstArticles.isSelectionEmpty()) {
		    String oldArticle;
		    ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		    oldArticle = model.getElementAt(lstArticles.getSelectedIndex()).toString();
		    String token[] = JOptionPane.showInputDialog("Unesite novi artikal (ID, naziv, cena):", oldArticle).split(" ");
		    model.edit(lstArticles.getSelectedIndex(), Integer.parseInt(token[0]), token[1], Integer.parseInt(token[2]));
		}
	    }
	});
	btnDelete.addActionListener(new ActionListener() {
	    // delete
	    @Override
	    public void actionPerformed(ActionEvent e) {
		if (!lstArticles.isSelectionEmpty()) {
		    ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		    model.delete(lstArticles.getSelectedIndex());
		}
	    }
	});
	btnLoad.addActionListener(new ActionListener() {
	    // load

	    @Override
	    public void actionPerformed(ActionEvent e) {
		ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		model.load("articles.data");
	    }
	});
	btnSave.addActionListener(new ActionListener() {
	    // save

	    @Override
	    public void actionPerformed(ActionEvent e) {
		ArticleListModel model = (ArticleListModel) lstArticles.getModel();
		model.save("articles.data");
	    }
	});
    }

    void center() {
	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width - w) / 2, (d.height - h) / 2);
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
	ArticleGUI gui = new ArticleGUI();
    }

}
